<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{directoryErrorMessageBrowser.filter.urlParameters}"/>
            <script>
                updateUrl("globalForm:filterUrlParameters");
                Event.observe("globalForm:filterUrlParameters", 'change',
                    function () {
                        updateUrl("globalForm:filterUrlParameters");
                    });
            </script>
            <s:div id="globalDiv">
                <h1>#{messages['net.ihe.gazelle.hpd.ProviderInformationDirectoryErrorLogs']}</h1>
                <gri:panel>
                    <f:facet name="header">#{messages['net.ihe.gazelle.hpd.DirectoryErrorMessages']}</f:facet>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.hpd.ThisPageGathersTheErrorMessagesWhichHaveBeenThro']}"
                            styleClass="help-block"/>
                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                        <ui:define name="panel_title">#{messages['gazelle.simu.SearchCriteria']}</ui:define>
                        <ui:define name="filter_buttons">
                            <a4j:commandLink title="#{messages['gazelle.common.button.Refresh']}"
                                             render="globalForm">
                                <s:span styleClass="gzl-icon-refresh"/>
                            </a4j:commandLink>

                            <a4j:commandLink actionListener="#{directoryErrorMessageBrowser.reset()}"
                                             title="#{messages['net.ihe.gazelle.hpd.ResetFilter']}" type="submit"
                                             execute="@this" render="globalForm">
                                <s:span styleClass="gzl-icon-times-circle"/>
                            </a4j:commandLink>
                        </ui:define>
                        <div class="row">
                            <div class="col-md-6">
                                <ui:include src="/filter/filterDate.xhtml">
                                    <ui:param name="filter" value="#{directoryErrorMessageBrowser.filter}"/>
                                    <ui:param name="filterWidth" value="240"/>
                                    <ui:param name="filterId" value="timestamp"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.hpd.Timestamp']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{directoryErrorMessageBrowser.filter}"/>
                                    <ui:param name="filterId" value="client"/>
                                    <ui:param name="filterName"
                                              value="#{messages['net.ihe.gazelle.hpd.SUTsIPAddress']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{directoryErrorMessageBrowser.filter}"/>
                                    <ui:param name="filterId" value="transaction"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.hpd.Transaction']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{directoryErrorMessageBrowser.filter}"/>
                                    <ui:param name="filterId" value="messageType"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.hpd.MessageType']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                            <div class="col-md-6">
                                <ui:include src="/filter/filter.xhtml">
                                    <ui:param name="filter" value="#{directoryErrorMessageBrowser.filter}"/>
                                    <ui:param name="filterId" value="errorCode"/>
                                    <ui:param name="filterName" value="#{messages['net.ihe.gazelle.hpd.ErrorCode']}"/>
                                    <ui:param name="filterForm" value="globalForm"/>
                                </ui:include>
                            </div>
                        </div>
                    </ui:decorate>
                    #{dataTableStateHolder.setDescendingOn('timestamp')}
                    <rich:dataTable value="#{directoryErrorMessageBrowser.data}" var="oc"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="messagesTable"
                                    render="errorTableds">
                        <g:column sortBy="#{'timestamp'}"
                                  sortOrder="#{dataTableStateHolder.sortOrders['timestamp']}">
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.Timestamp']}"/>
                            </ui:define>
                            <g:date value="#{oc.timestamp}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.SUTsIPAddress']}"/>
                            </ui:define>
                            <h:outputText value="#{oc.client}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.Transaction']}"/>
                            </ui:define>
                            <h:outputText value="#{oc.transactionKeyword}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.RequestType']}"/>
                            </ui:define>
                            <h:outputText value="#{oc.messageType}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['net.ihe.gazelle.hpd.ErrorCode']}"/>
                            </ui:define>
                            <h:outputText value="#{oc.code}"/>
                            <h:outputText value=" (#{oc.codeMeaning})" rendered="#{not empty oc.codeMeaning}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">
                                <h:outputText value="#{messages['users.Action']}"/>
                            </ui:define>
                            <div class="row">
                                <a4j:commandLink actionListener="#{directoryErrorMessageBrowser.setSelectedMessage(oc)}"
                                                 oncomplete="jq162('#messageDetails').modal('show')"
                                                 render="messageDetails, messageDetailsDiv">
                                    <s:span styleClass="gzl-icon-search"/>
                                </a4j:commandLink>
                                <h:outputLink
                                        value="#{directoryErrorMessageBrowser.getLinkToTransactionInstance(oc.transactionInstanceId)}">
                                    <span class="gzl-icon-email"/>
                                </h:outputLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="errorTableds"/>
                                <ui:param name="dataTableId" value="messagesTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </gri:panel>
            </s:div>
            <ui:decorate template="/layout/popup/_popup_title.xhtml">
                <ui:param name="popup_id" value="messageDetails"/>
                <ui:define name="popup_title">#{messages['users.Details']}</ui:define>
                <s:div id="messageDetailsDiv">
                    <dl class="dl-horizontal">
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Timestamp']}</ui:define>
                            <g:date value="#{directoryErrorMessageBrowser.selectedMessage.timestamp}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.SUT']}</ui:define>
                            <h:outputText value="#{directoryErrorMessageBrowser.selectedMessage.client}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.ErrorCode_2']}</ui:define>
                            <h:outputText value="#{directoryErrorMessageBrowser.selectedMessage.code}"/>
                            <h:outputText value=" (#{directoryErrorMessageBrowser.selectedMessage.codeMeaning})"
                                          rendered="#{not empty directoryErrorMessageBrowser.selectedMessage.codeMeaning}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.ErrorMessage']}</ui:define>
                            <h:outputText value="#{directoryErrorMessageBrowser.selectedMessage.message}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.RelativeMessage']}</ui:define>
                            <h:outputLink
                                    value="#{directoryErrorMessageBrowser.getLinkToTransactionInstance(directoryErrorMessageBrowser.selectedMessage.transactionInstanceId)}">
                                <h:outputText
                                        value="#{directoryErrorMessageBrowser.selectedMessage.transactionInstanceId}"/>
                            </h:outputLink>
                        </s:decorate>
                    </dl>
                </s:div>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
